## ferret-vis 7.5.0

=== bench/Makefile ===
#
# Makefile for the Ferret bench subdirectory
#

# include platform specific macro definitions for make_stream_file
include ../site_specific.mk
include ../platform_specific.mk.$(BUILDTYPE)

## Run all the benchmark tests, including those requiring remote data
## (environment variable SKIP_REMOTE is empty)
.PHONY: check
check:
	@$(MAKE) "SKIP_REMOTE=" run_tests
	@$(MAKE) "SKIP_REMOTE=" compare_plots
	@$(MAKE) "SKIP_REMOTE=" compare_logs

## Run all the benchmark tests except those requiring remote data
## (environment variable SKIP_REMOTE is not empty)
.PHONY: check_noremote
check_noremote:
	@$(MAKE) "SKIP_REMOTE=XXXX" run_tests
	@$(MAKE) "SKIP_REMOTE=XXXX" compare_plots
	@$(MAKE) "SKIP_REMOTE=XXXX" compare_logs

## Execute the RUN_TESTS.sh test suite
## If the environment variable SKIP_REMOTE is not empty, skips tests requiring remote data
.PHONY: run_tests
run_tests:
	@( \
	    ferret_exe=`which ferret` ;\
	    if [ $$ferret_exe = "" -o "$(FER_DIR)" = "" ] ; then \
	        echo "*** Ferret must be installed and the ferret_paths script must have sourced for these tests ***" ;\
	        exit 1 ;\
	    fi ;\
	    echo "Using $$ferret_exe" ;\
	    SED_EXTREGEX_FLAG="$(SED_EXTREGEX_FLAG)" ;\
	    export SED_EXTREGEX_FLAG ;\
	    ./RUN_TESTS.sh $$ferret_exe "$(FER_EXTERNAL_FUNCTIONS)" \
	)

## Compare the plots from executing the RUN_TESTS.sh test suite with those saved.
## If the environment variable SKIP_REMOTE is empty, compares to those under "test_result";
## otherwise compares to those under "test_results_noremote"
.PHONY: compare_plots
compare_plots:
	-@( \
	    if [ -z "$(SKIP_REMOTE)" ] ; then \
	        results_dir="test_results" ;\
	    else \
	        results_dir="test_results_noremote" ;\
	    fi ;\
	    echo "Comparing GIF files to those in bench/$$results_dir" ;\
	    for img in `find . -name '*.gif' -a \! -regex './metafile_masters_.*' -exec basename {} \; | sort -u` ; do \
	        if [ ! -f $$img ] ; then \
	            echo "*** File $$img is missing ***" ;\
	        elif [ ! -f $$results_dir/$$img ] ; then \
	            echo "*** File $$results_dir/$$img is missing ***" ;\
	        elif diff -q $$img $$results_dir/$$img ; then \
	            echo "Files $$img and $$results_dir/$$img are identical" ;\
	        else \
	            compare $$img $$results_dir/$$img $${img}_diff.gif ; \
	        fi ;\
	    done \
	)
	@echo ''
	@echo 'Inspect the *_diff.gif files for actual differences in the images'
	@echo ''

## Compare the log, err, and ncdump results from executing the RUN_TESTS.sh test suite.
## If the environment variable SKIP_REMOTE is empty, compares to those under "test_result";
## otherwise compares to those under "test_results_noremote"
.PHONY: compare_logs
compare_logs:
	-@( \
	    if [ -z "$(SKIP_REMOTE)" ] ; then \
	        results_dir="test_results" ;\
	    else \
	        results_dir="test_results_noremote" ;\
	    fi ;\
	    datetag=`date +'%d%h%yAT'|tr '[A-Z]' '[a-z]'` ;\
	    logfile=`/bin/ls -1 all_$${datetag}*_log` ;\
	    if [ -z "$$logfile" ] ; then \
	        echo "*** No run_tests results log file from today found ***" ;\
	        exit 1 ;\
	    fi ;\
	    if [ `echo "$${logfile[@]}" | wc -l` -ne 1 ] ; then \
	        echo "*** Multiple run_tests results logs from today found ***" ;\
	        exit 1 ;\
	    fi ;\
	    echo "Comparing $$logfile to bench/$$results_dir/ferret_run_tests_log" ;\
	    diff $$logfile $$results_dir/ferret_run_tests_log 1> ferret_run_tests_log.diff 2>&1 ;\
	    errfile=`echo $$logfile | sed -e "s%log%err%"` ;\
	    echo "Comparing $$errfile to bench/$$results_dir/ferret_run_tests_err" ;\
	    diff $$errfile $$results_dir/ferret_run_tests_err 1> ferret_run_tests_err.diff 2>&1 ;\
	    ncdfile=`echo $$logfile | sed -e "s%log%ncdump%"` ;\
	    echo "Comparing $$ncdfile to bench/$$results_dir/ferret_run_tests_ncdump" ;\
	    diff $$ncdfile $$results_dir/ferret_run_tests_ncdump 1> ferret_run_tests_ncdump.diff 2>&1 ;\
	    echo '' ;\
	    echo 'Inspect the ferret_run_tests_*.diff files for actual differences in the output' \
	)
	@echo ''

.PHONY: clean
clean:
	rm -f all_*_ncdump all_*_err all_*_log all_*_ncdump_orig all_*_err_orig all_*_log_orig cleanups.sed
	rm -f *.plt* *.gif* *.diff* ferret.jnl*
	rm -f `cat TRASH_FILES`
	rm -f all_ncdump.out fort.41 make_stream_file
	rm -fr subdir tmp aggf

make_stream_file: make_stream_file.F
	$(FC) $(FFLAGS) make_stream_file.F -o make_stream_file

#
# End of Makefile
#

=== fer/Makefile ===
#
# Makefile (for the FERRET/fer code)
#
# August 11 1997
# Jonathan Callahan (with some help from Joe Sirott)
#
# 10/97 *kob*  - pltform specific files will reside in ppl directory and be 
#		 links to actual files in fer directory
# 7/98 *kob* - reworking prior to source code distribution. add in 
#	       fmt are as well so one make command compiles/links all
# 7/99 *sh* - corrected misbehavior of make debug -- make update was not called
# 8/99 *acm* - Add EFUOBJS and ef_utility to DIRS and LIBS so to include 
#              External Functions utility functions in the executable.
#              (see note in ef_utility/Makefile: Don't put these in a library.)
# 12/99 *sh* - changed "debug" to "alpha" as DEBUG_TITLE
#  3/00 *acm* - Add efi library External Functions, internally linked
#  5/00 *kob* - Added a "make update" to all entries in order to properly
#	        update the date for each make.  this was also necessary when
#		compiling Ferret initially in order to create 
#	        special/xmake_date_data.F  and special/xrevision_type_data.F
#  v5.4 10/01*kob* - removed explicit reference to libXpm.a  - move it instead 
#                  to system specific SYS_LIBS macro in platform specific files
#  v5.4 10/01 *kob* - add the removal of .f files - for linux
#  v5.41 4/02 *acm* - Add -g flag for debug compiles of C code.  
# v5.54  8/04 *acm* - Add target "profiling", to compile with -pg option.
# v6.1 beta 3/06 *acm* - For Beta release to GFDL, add (beta) as DEBUG_TITLE
# v6.1 release 3/06 *acm* - Remove (beta) as DEBUG_TITLE for official release
#  v6.6 07/10 *kms* - added threddsBrowser to DIRS (for clean)
#                     created threddsBrowser target and added it to all
# v6.7 4/11 *kms* - renamed old "all" target to "build" and made the "all"
#                   target go to the desired default target ncdf4;
#                   cleaned-up tags
#  v6.8  7/13 *kms* - removed threddsBrowser (moved to top level since it is a separate app)
#  v6.97 2/16 *acm* - restore "profiling" target
#  V698  3/16 *acm* Removed Philander-Seigel code including ocn/ directory
#  V702 1/17 *sh* dynamic mem mgmt for trac #2369 calls mem from ccr so had to
#        stick another mem at tthe end of the FERLIBS list.  Ugly solution.
#        Also shifted fmt after mem so that the new LIFINT8 gets picked up
#  V722 *kms* 10/17 Remove threddsBrowser (too big, outdated, and unused)
#  V74  *acm*  1/18 Remove save_arg_pointers.o, diffs because of dynamic-memory updates
# 
# include platform specific macro definitions
#

include ../site_specific.mk
include ../platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

#*kob* 2/99 - set GUI_FAKES so that by default it is assumed no gui
#	      stuff is needed.  in order to allow the "make" command 
#	      by itself to work.

GUI_FAKES = special/gui_fakes.o

DIRS	= agg ccr ctx dat doo efi efn ef_utility gnl ino mem fmt \
	 plt rpn special stk utl xeq

LIBS	= agg ccr ctx dat doo efi efn ef_utility gnl ino mem fmt \
	 plt rpn stk utl xeq

CLEANDIRS = $(DIRS)

DEPDIRS = ccr

FERLIBS = -lxeq -lagg -lgnl  -lccr -lferplt -lrpn -lstk -ldoo  \
	-lctx -lino -lmem -lfmt -lutl -ldat -lccr -lmem -lefi -lefn

PPLLIBS = -lplt -lpll -lsym -lcmp -lour -lepi -lusr -ltmap

FERMAIN = ccr/fermain_c.o

# explicitly include block data object files
DATA_OBJS = dat/*.o ../fmt/src/x*.o ../ppl/plot/ppldata.o

FEROBJS_DFLT = $(DATA_OBJS) special/linux_routines.o \
	special/ferret_dispatch.o special/xmake_date_data.o special/fakes3.o \
	special/xrevision_type_data.o special/xplatform_type_data.o special/FerMem_routines.o

FEROBJS = $(FEROBJS_DFLT)

PPLOBJS =  ../ppl/tmapadds/*.o 

EFUOBJS = ef_utility/*.o

EFIOBJS = efi/*.o

EXECNAME = ferret_c

WHATGKS = xgks

GKSLIB = ../xgks/src/lib/libxgks.a

EF_CMNS = common/EF_Util.cmn common/EF_Util.parm common/EF_mem_subsc.cmn

#
# Targets
#

.PHONY: all
all: ncdf4

.PHONY: build
build: update fmt_libraries fer_libraries ppl_libraries special_code ferret

.PHONY: ncdf4
ncdf4:
	mkdir -p ../lib
	$(MAKE) "CFLAGS=$(CFLAGS) $(OPT_FLAGS)" \
		"FFLAGS=$(FFLAGS) $(OPT_FLAGS)" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(PPLUS_OPT_FLAGS)" \
		"DEBUG_TITLE = optimized" \
		"GUI_FAKES=special/gui_fakes.o" \
		build

.PHONY: debug
debug:
	mkdir -p ../lib
	$(MAKE) "CFLAGS = $(CFLAGS) $(DBG_FLAGS)"  \
		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
		"DEBUG_TITLE = debug" \
		"GUI_FAKES=special/gui_fakes.o" \
		build

# Debug but also print all memory allocations, reallocations, and frees to 
# file "memorydebug.txt".  Initialize allocated memory with non-zero values. 
# Expect this to be a lot slower due to all the (intentionally inefficient 
# but safe) file operations.
.PHONY: memorydebug
memorydebug:
	mkdir -p ../lib
	$(MAKE) "CFLAGS = -DMEMORYDEBUG $(CFLAGS) $(DBG_FLAGS)"  \
		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
		"DEBUG_TITLE = memorydebug" \
		"GUI_FAKES=special/gui_fakes.o" \
		build

.PHONY: profiling
profiling:
	mkdir -p ../lib
	$(MAKE) "CFLAGS = $(CFLAGS) $(PROF_FLAGS) "  \
		"FFLAGS = $(FFLAGS) $(PROF_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(PROF_FLAGS)" \
		"LDFLAGS = $(LDFLAGS) $(PROF_FLAGS)" \
		"DEBUG_TITLE = profiling" \
		"GUI_FAKES=special/gui_fakes.o" build

.PHONY: ferret
ferret:	
	- mv $(EXECNAME) $(EXECNAME)_`ls -l $(EXECNAME) | awk '{print $$6"_"$$7}' | tr [A-Z] [a-z]`
	- $(LD) $(LDFLAGS) -L../lib \
		$(FERMAIN) \
		$(FEROBJS) \
		$(GUI_FAKES) \
		$(PPLOBJS) \
		$(EFUOBJS) \
		$(EFIOBJS) \
		$(FERLIBS) \
		$(PPLLIBS) \
		$(READLINELIB) \
		$(CDFLIB) \
		$(HDFLIB) \
		$(GKSLIB) \
		$(SYSLIB) \
		-o $(EXECNAME)
	chmod +x $(EXECNAME)

.PHONY: update
update:
	- mv $(EXECNAME) $(EXECNAME)_`ls -l $(EXECNAME) | awk '{print $$6"_"$$7}' | tr [A-Z] [a-z]`
	${MAKE} update_date DATE=`/bin/date +%D`
	rm -f special/xrevision_type_data.[Ffo]
	sed -e 's&mmmmmmmm&($(DEBUG_TITLE)/$(GUI))&' -e 's&(/&(&' -e 's&/)&)&' < special/xrevision_type_data.template > special/xrevision_type_data.F 
	rm -f special/xplatform_type_data.[Ffo]
	sed -e 's&mmmmmmmm&$(PLATFORM)&' -e 's&(/&(&' -e 's&/)&)&' < special/xplatform_type_data.template > special/xplatform_type_data.F 
	(cd special; make)

.PHONY: update_date
update_date:
	rm -f special/xmake_date_data.[Ffo]
	sed "s&xxxxxxxx&$(DATE)&" <special/xmake_date_data.template >special/xmake_date_data.F

.PHONY: libraries
libraries: ppl_libraries fer_libraries

.PHONY: fmt_libraries
fmt_libraries:
	$(MAKE) -C ../fmt/src

.PHONY: fer_libraries
fer_libraries:
	for i in $(LIBS) ; \
        do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done

.PHONY: ppl_libraries
ppl_libraries:
	$(MAKE) -C ../ppl all

.PHONY: special_code
special_code:
	$(MAKE) -C special all

.PHONY: clean
clean: fmt_clean ppl_clean fer_clean 
	- mv $(EXECNAME) $(EXECNAME)_`ls -l $(EXECNAME) | awk '{print $$6"_"$$7}' | tr [A-Z] [a-z]`
	rm -f ../lib/*.a ../lib/*.so
	rm -f special/xmake_date_data.F special/xplatform_type_data.F special/xrevision_type_data.F

.PHONY: ppl_clean
ppl_clean:
	$(MAKE) -C ../ppl clean

.PHONY: fer_clean
fer_clean:
	for i in $(CLEANDIRS) ; \
        do \
            $(MAKE) -C $$i clean ; \
        done

.PHONY: fmt_clean
fmt_clean:
	$(MAKE) -C ../fmt/src clean

#
# End of Makefile
#

=== external_functions/closest_in_list/Makefile ===
#
# Makefile for Ferret External Functions
#
# *sh* 2/26/00
#
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $*.o -o $*.so

#
# Targets
#

all:	closest_in_zlist.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/contributed/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke  
#  remove refs to ef_utility/*.o  (now in ferret executable)
# *sh* 2/2000 - removed SAMPLEIJ from target list (replaced by SAMPLEXY)
#
# *acm* 1/2001 - incorporate "make debug" as per SH Makefiles
#  acm  2/2001   debug macros
#  acm  5/2007   removed fill_xy from target list; now statically-linked.
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $*.o -o $*.so

#
# Targets
#

#all:    chdir.so neutral.so fill_xy.so pco2.so
#all:    chdir.so neutral.so fill_xy.so
all:	

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/date_and_time/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke  
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
# dec-00 adapted for "date_and_time" function
# 2/01 *sh* - restored the -C qualifier for debug target

#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

DAT_OBJS = date_decode.o time_decode.o secs_to_ymdhms.o

#
# Rules
#

.c.so:
	$(CC) $(DATFLAGS) $(CFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(DAT_OBJS) $*.o -o $*.so 

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(DAT_OBJS) $*.o -o $*.so 

#
# Targets
#

# all:	date_decode.o time_decode.o secs_to_ymdhms.o date1900.o date1900.so minutes24.o minutes24.so days1900toymdhms.o days1900toymdhms.so

all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/decimate/Makefile ===
#
# Makefile for Ferret External Functions
#
#
# include platform specific macro definitions
#
include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)
 
#
# Macros
#

.SUFFIXES: .so
SUB_OBJS = piecewise_subs.o

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $(SUB_OBJS) $*.o -o $*.so

#
# Targets
#

#all:	$(SUB_OBJS) piecewise.so piecewise3.so piecewise1.so piecewise2.so separate.so sample_fast_i.so sample_rows.so apply_qc.so sample_fast_i_str.so sample_rows.so
all:	$(SUB_OBJS) piecewise3.so separate.so separate_str.so sample_fast_i.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) -g -Ddebug" "CFLAGS = $(CFLAGS) -g -Ddebug"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/eof/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke  
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM  2/2001  debug macros
#  ACM  Jul 2001 Move to statically linked code in fer/efi.  name functions
#                eofspace, eofstat, eoftfunc; with same code as in fer/efi,
#                but with different INCLUDE statements for use in testing
#                as dynamically-linked functions.
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

SUB_OBJS = eofsubs.o 

#
# Rules
#

#   once eof_space etc are linked into Ferret dont need SUB_OBJS

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o -o $*.so 

#
# Targets
#

all:	eofsubs.o eof_space_tgap.so eof_tfunc_tgap.so eof_stat_tgap.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

# To make a tarfile with the older functions that work on gappy timeseries:
# make; make tarfile
tarfile:
	rm -f fer_eof_gappy_timeseries_fcns.tar*
	tar cf fer_eof_gappy_timeseries_fcns.tar *.so
	gzip -9 fer_eof_gappy_timeseries_fcns.tar

#
# End of Makefile
#

=== external_functions/examples/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke  
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros 
#  ACM 2/2002  change targets to all and extras; somehow standard
#               not working well w/ linux.
#
# include platform specific macro definitions
#
include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)
 
#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $*.o -o $*.so

#
# Targets
#

all:	add_9.so appende.so avet.so dates.so factorial.so pass_thru.so percent_good_t.so \
	storage.so string_arg.so subtract.so earth_distance.so
debug:
	$(MAKE) "FFLAGS = $(FFLAGS) -g -Ddebug" "CFLAGS = $(CFLAGS) -g -Ddebug"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/godae_obs/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
# dec-00 adapted for "godae_obs" function
# ACM 2/2001

#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

GOB_OBJS = ocn_obs.o

#
# Rules
#

.c.so:
	$(CC) $(GOBFLAGS) $(CFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(GOB_OBJS) $*.o -o $*.so 

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(GOB_OBJS) $*.o -o $*.so 

#
# Targets
#

all:	ocn_obs.o godae_obs.o godae_obs.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/lanczos/Makefile ===
#
# Makefile for Ferret External Functions
#
# lanczos function from Brett McDaniel was in 
# Fortran 90.  Translated to f77 by Ansley Manke  6/25/04
#
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)
 
#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SYSLIBS) $*.o -o $*.so

#
# Targets
#

# all:    lanczos.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/ncedit/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke  
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros 
#  ACM 2/2002  change targets to all and extras; somehow standard
#               not working well w/ linux.
#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o -o $*.so 

.F.o:
	$(FC) $(FFLAGS) -c $<

#
# Targets
#

all:	nco.so nco_attr.so 

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/obs_viz/Makefile ===
#
# Makefile for Ferret External Functions
#
# 2/01 *sh*

#
# include platform specific macro definitions
#

include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

DAT_OBJS = flag2ddups.o

#
# Rules
#

.c.so:
	$(CC) $(DATFLAGS) $(CFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(DAT_OBJS) $*.o -o $*.so 

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(DAT_OBJS) $*.o -o $*.so 

#
# Targets
#

# all:	$(DAT_OBJS) scat2ddups.o scat2ddups.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== debian/changelog ===
ferret-vis (7.5.0-2build1) focal; urgency=medium

  * No-change rebuild for netcdf soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 30 Jan 2020 18:01:09 +0100

ferret-vis (7.5.0-2) unstable; urgency=medium

  * override dh_dwz for now as it causes issues on mips builds
  * Standards-Version: 4.4.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 14 Jul 2019 15:09:39 +0100

ferret-vis (7.5.0-1) unstable; urgency=medium

  * New upstream release
  * B-D on gfortran | fortran-compiler
  * Ship gfortran, flang versions of config files
  * Drop recommends: on python-ferret
  * Now use debhelper 12

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Feb 2019 15:51:24 +0000

=== debian/control ===
Source: ferret-vis
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 12),
 dh-elpa,
 libreadline-dev, 
 libcurl4-openssl-dev | libcurl-dev, 
 libxgks-dev (>= 2.6.1+dfsg.2-4) , 
 libncurses-dev, 
 gfortran | fortran-compiler, 
 libnetcdf-dev, libnetcdff-dev,
 libxmu-headers, 
 csh, 
 libxt-dev 
Standards-Version: 4.4.0
Homepage: https://ferret.pmel.noaa.gov/Ferret/home
Vcs-Browser: https://salsa.debian.org:/science-team/ferret-vis.git
Vcs-Git: https://salsa.debian.org:/science-team/ferret-vis.git

Package: ferret-vis
Architecture: any
Depends: ${misc:Depends}, 
 ${shlibs:Depends},
 dh-elpa,
 ${elpa:Depends}, 
 tcsh | csh | c-shell
Recommends: ferret-datasets, 
 python3-ferret
Description: Interactive data visualization and analysis environment
 Ferret is an interactive computer visualization and analysis environment
 designed to meet the needs of oceanographers and meteorologists analyzing 
 large and complex gridded data sets. It can transparently access extensive
 remote Internet data bases using OPeNDAP (formerly known as DODS)
 .
 Ferret has a Mathematica-like flexibility, geophysical formatting, 
 "intelligent" connection to its data base, memory management for very large 
 calculations, and symmetrical processing in 4 dimensions. It can work on both
 gridded and non-gridded datasets.

 
Package: ferret-datasets
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: ferret-vis
Description: Datasets for use with Ferret Visualisation and analysis suite
 These datasets contain reference climatologies and grids for use with ferret.
 They include:
  * etopo120            relief of the earth's surface at 120-minute resolution
  * etopo60             relief of the earth's surface at 60-minute resolution
  * levitus_climatology subset of the Climatological Atlas of the World Oceans 
                        by Sydney Levitus (Note: the updated World Ocean Atlas,
                        1994, is also available with Ferret)
  * coads_climatology   12-month climatology derived from 1946–1989 of the 
                        Comprehensive Ocean/Atmosphere Data Set
  * monthly_navy_winds  monthly-averaged Naval Fleet Numerical Oceanography 
                        Center global marine winds (1982–1990)
  * esku_heat_budget    Esbensen-Kushnir 4×5 degree monthly climatology of the
                        global ocean heat budget (25 variables)

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Set for reproducibility
LC_ALL=C
export LC_ALL

# magic debhelper rule
%:
	dh $@ --with elpa

FER_EXT:=$(CURDIR)/debian/ferret-vis/usr/lib/ferret-vis/external_functions
ARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/${ARCH}
INSTALLDIR:=$(CURDIR)/debian/tmp
# FC set to f77 by default in make
# Read default compiler name unless FC is actually set
ifeq ($(FC),f77)
  FC:=$(shell basename $(shell readlink /etc/alternatives/f95))
endif


site_specific.mk:
	sed -e 's%@ARCH@%${ARCH}%' \
		-e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@INSTALLDIR@%${INSTALLDIR}%' \
		< debian/site_specific.mk.in > site_specific.mk
	cp debian/platform_specific.mk.debian.$(FC) platform_specific.mk.debian
	cp site_specific.mk platform_specific.mk.debian  external_functions/ef_utility

override_dh_auto_build: site_specific.mk
	$(MAKE) -C fer HOSTTYPE=debian update all
	-$(MAKE) -C external_functions HOSTTYPE=debian
	$(MAKE) -C gksm2ps debian

override_dh_install:
	dh_installdirs
	mkdir -p  $(FER_EXT)
	-$(MAKE) -C external_functions install HOSTTYPE=debian \
		FER_LOCAL_EXTFCNS=$(FER_EXT) FER_DIR=$(CURDIR)/debian/tmp
	dh_install
	# Drop extension (allow to fail on binary-only build)
	-mv debian/ferret-vis/usr/bin/Fpatch.csh debian/ferret-vis/usr/bin/Fpatch

override_dh_elpa_test:
	@echo pass tests

override_dh_dwz:
	@echo "DWZ bypassed in this build: issues with dwz on mips"

override_auto_dh_test:
	(cd bench && ./run_all )

override_dh_auto_clean: 
	# use system xpm.h, not supplied ones
	rm -f fer/gui/xpm*.h
	find . -type l  -delete
	find . -name '*.o' -delete
	find . -name '*.so' -delete
	find external_functions -type l -exec rm {} \;
	[ ! -f site_specific.mk ] || $(MAKE) -C gksm2ps clean
	[ ! -f fer/platform_specific_flags.mk.debian ]  || $(MAKE) -C fer clean HOSTTYPE=debian 
	rm -rf lib gksm2ps/gksm2ps fer/ferret_c*

## ferret-vis 7.6.0~beta

=== debian/changelog ===
ferret-vis (7.6.0~beta-2) unstable; urgency=medium

  * FER_GO env. variable expects spaces, not colons as separators.
    Patch from Malte zu Klampen to fix. Closes: #960592

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 09 Jun 2020 18:37:34 +0100

ferret-vis (7.6.0~beta-1) unstable; urgency=medium

  * New upstream release
  * Use debhelper-compat (= 12)
  * Standards-Version: 4.5.0
  * Allow -fallow-argument-mismatch when using gfortran-10
  * gcc10.patch from pyferret for BOZ changes. Closes: #957203
  * xgks.patch: Link against libxgks-$(FC) 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 04 May 2020 16:44:13 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 12),
  dh-elpa,
  libreadline-dev, 
  libcurl4-openssl-dev | libcurl-dev, 
@@ -13,7 +13,7 @@
  libxmu-headers, 
  csh, 
  libxt-dev 
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Homepage: https://ferret.pmel.noaa.gov/Ferret/home
 Vcs-Browser: https://salsa.debian.org:/science-team/ferret-vis.git
 Vcs-Git: https://salsa.debian.org:/science-team/ferret-vis.git
